<?php

/*
 * AbraFood Task
 * Exemplo: php ODH-ABF.php cloud9
 */
 
date_default_timezone_set("America/Sao_Paulo");

class Service {
    
    const CLIENT_AUTH    = "81743A8E8D41AF82A4807097CDF4BEC2DDDB9E6334BECCFED4D46FC783A8CA2E";
    const SLEEP_INTERVAL = 10;

    public function run () {
        
        /* 
         * [1] Current client argument 
         * [2] Current execution log path
         */
        global $argv;

        if(!isset($argv[1])) 
            throw new \Exception("Invalid client");

        $client      = $argv[1];
        $clientsFile = file_get_contents(__DIR__ . "/../config/clients.json");
        $clients     = json_decode($clientsFile, true);

        if(!isset($clients[$client]) || empty($clients[$client])) 
            throw new \Exception("Invalid client");

        while (true) {
            try {

                $url      = $clients[$client];
                $auth     = $this->getAuth();
                $response = $this->request($url, $auth);

                echo $response;
            } catch (\Exception $e) {
                echo $e->getMessage() . PHP_EOL;
            }
            
            sleep(self::SLEEP_INTERVAL);
        }
    }

    private function getAuth() {
        return ['auth' => self::CLIENT_AUTH];
    }
    
    private function request($url, $auth) {
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type:application/json']);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($auth));   
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_TIMEOUT, 60);

        $result = curl_exec($ch);
        curl_close($ch);
        return $result;
    }
}

$service = new Service();
$service->run(); 